/* Subgame G: Platform */

int x_origin,y_origin;

void infoscreenG()
{
	if (seeninfo['G']) return;
	seeninfo['G']=1;
	titlepal(gamma);
	memset(shad,0,40*xres);
	memset(shad+40*xres,160,400*xres);
	memset(shad+440*xres,0,40*xres);
	bwrite(60,60,xres,"Subgame G:",15);
	bwrite(60,80,xres,"Untitled",200);
	write(60,100,xres/2-60,"Objective",0,1);
	write(60,110,xres/2-60,"Collect all the purple crystals.",15,200);
	write(60,120,xres/2-60,"Risks",0,1);
	write(60,130,xres/2-60,"Mostly to do with falling down holes.",15,200);
	write(60,170,xres/2-60,"Rewards",0,1);
	write(60,180,xres/2-60,"I'll get back to you on that one.",15,200);
	write(60,220,xres/2-60,"I haven't made this subgame yet.",15,200);
	ccl(0); Sleep(500);
	while (!kbhit && !dealwithmessages());
	writepal(gamma);
}
/*
void rectss(int x,int y,int xs,int ys,const unsigned char c)
{
	int n;
	unsigned char *p;
	if (x<0) {xs+=x; if (xs<0) return; x=0;}
	if (y<0) {ys+=y; if (ys<0) return; y=0;}
	if (x>=xres/2) return;
	if (y>=yres/2) return;
	if (x+xs>xres/2) xs=xres/2-x;
	if (y+ys>yres/2) ys=yres/2-y;
	p=shad+(y+y_origin)*xres+x+x_origin;
	for (n=0;n<ys;n++)
	{
		memset(p,c,xs);
		p+=xres;
	}
}
*/
void circlefillss(const float x,const float y,const float r,const unsigned char c)
{
	int py;
	int ymin=ceil(y-r),ymax=floor(y+r);
	if (ymin<0) ymin=0;
	if (ymin>=yres/2) ymin=yres/2-1;
	if (ymax<0) ymax=0;
	if (ymax>=yres/2) ymax=yres/2-1;
	for (py=ymin;py<=ymax;py++)
	{
		float rx=sqrt(r*r-sq(py-y));
		int xmin=x-rx,xmax=x+rx;
		if (xmin<0) xmin=0;
		if (xmin>=xres/2) xmin=xres/2-1;
		if (xmax<0) xmax=0;
		if (xmax>=xres/2) xmax=xres/2-1;
		if (xmax>xmin) memset(shad+(py+y_origin)*xres+xmin+x_origin,c,xmax-xmin+1);
	}
}
/*
void liness(float x1,float y1,float x2,float y2,const unsigned char c)
{
	float dx=x2-x1,dy=y2-y1,k;
	if (dx*dx+dy*dy<0.1)
	{
		if (x1>=0 && x1<xres/2 && y1>=0 && y1<yres/2)
			putpix(x1+x_origin,y1+y_origin,c);
		return;
	}
	if (dx+dy<0)
	{
		dx=-dx; dy=-dy;
		k=x1; x1=x2; x2=k;
		k=y1; y1=y2; y2=k;
	}
	if (dx>dy)
	{
		k=dy/dx;
		for (;x1<=x2;x1++)
		{
			if (x1>=0 && x1<xres/2 && y1>=0 && y1<yres/2)
				shad[(int)x1+x_origin+((int)y1+y_origin)*xres]=c;
			y1+=k;
		}
	}
	else
	{
		k=dx/dy;
		for (;y1<=y2;y1++)
		{
			if (x1>=0 && x1<xres/2 && y1>=0 && y1<yres/2)
				shad[(int)x1+x_origin+((int)y1+y_origin)*xres]=c;
			x1+=k;
		}
	}
}
*/
void mskbitss(const int x,const int y,const unsigned char *bitmap)
{
	int px,py; unsigned char *p=bitmap+2,c;
	for (py=0;py<bitmap[1];py++)
		if (y+py>=0 && y+py<yres/2)
		{
			for (px=0;px<bitmap[0];px++,p++)
				if ((c=*p)!=255)
					if (x+px>=0 && x+px<xres/2)
						shad[x+px+x_origin+(y+py+y_origin)*xres]=c;
		}
		else p+=bitmap[0];
}

enum sg_retcode subgameG(const int them) /* Subgame G: Platform */
{
	int p,n,i,j,k,x,y;
	char str[100];
	int numpresent=them%2+them/2%2+them/4%2+them/8;
	int bm,bmax=100;
	float *bx=(float *)malloc(bmax*sizeof(float)),*by=(float *)malloc(bmax*sizeof(float)),
		*bxs=(float *)malloc(bmax*sizeof(float)),*bys=(float *)malloc(bmax*sizeof(float)),
		*br=(float *)malloc(bmax*sizeof(float)),*bgr=(unsigned char *)malloc(bmax);
	unsigned char *bo=(unsigned char *)malloc(bmax),col[MAXP]={12,9,11,14};
	int gxs=100,gys=100;
	unsigned char **grid=(unsigned char **)malloc(gxs*sizeof(unsigned char *));
	int blocks=5;
	unsigned char **block=(unsigned char **)malloc(blocks*sizeof(unsigned char *)),
		*crystal=(unsigned char *)malloc(2+25*25);
	float cx[MAXP],cy[MAXP];
	int xorig[MAXP],yorig[MAXP],left;
	float dt=1,g=0.05;
	enum sg_retcode ret=TBA;
	infoscreenG();
	for (n=0;n<blocks;n++) // Generate block graphics
	{
		block[n]=(unsigned char *)malloc(2502);
		block[n][0]=block[n][1]=50;
		memset(block[n]+2,255,2500);
	}
	for (x=0;x<50;x++) for (y=0;y<50;y++)
	{
		i=2+x+y*50;
		block[1][i]=sin(sin(0.125*y)*3+sin(x)*3)*3+frnd(2)+23;
		block[1][i]=Max(16,block[1][i]-(0.05*x+0.05*y+frnd(1)));
		if (x<25 && y<25) block[2][i]=128+5*(int)(3.5-0.05*y+0.5*sin(1.5*x)+0.5*sin(1.5*y));
		if (x>=50-y) block[3][i]=32+(x+y%2)/2;
	}
	readbit(crystal,".\\ncgi.dat",10449);
	if (numpresent==1) clb(1);
	else if (numpresent==2) // Set up subscreens
	{
		i=0;
		for participants(p)
		{
			xorig[p]=i*xres/2;
			yorig[p]=yres/4;
			rectb(xorig[p],yorig[p],xres/2,yres/2,1);
			i++;
		}
	}
	else if (numpresent==3)
	{
		i=0;
		for participants(p)
		{
			xorig[p]=i*xres/4;
			yorig[p]=(i%2)*yres/2;
			rectb(xorig[p],yorig[p],xres/2,yres/2,1);
			i++;
		}
	}
	else if (numpresent==4)
	{
		i=0;
		for participants(p)
		{
			xorig[p]=(i%2)*xres/2;
			yorig[p]=(i/2)*yres/2;
			rectb(xorig[p],yorig[p],xres/2,yres/2,1);
			i++;
		}
	}
	left=0;
	for (x=0;x<gxs;x++) // Load level
	{
		grid[x]=(unsigned char *)malloc(gys);
		for (y=0;y<gys;y++)
		{
			if ((x/5+y)%(14-y/10)==0) grid[x][y]=1;
			if ((x-y+1000)%(16-y/10)==0) grid[x][y]=2;
			if (!rnd(30)) grid[x][y]=3;
			if (!rnd(100)) {grid[x][y]=100; left++;}
		}
	}
	bm=0;
	for participants(p)
	{
		bx[bm]=gxs/2*50+p*100-200+rnd(50);
		by[bm]=gys/2*50;
		cx[p]=bx[bm]-xres/2; cy[p]=by[bm]-yres/2;
		bxs[bm]=bys[bm]=0;
		br[bm]=15; bo[bm]=p;
		bgr[bm]=0;
		bm++;
	}
	while (ret==TBA) // <G> Main Loop
	{
		double framestart=GetTickCount();
		if (KEY(VK_P)) if (pause()) return Error;
		if (KEY(VK_ESCAPE) || KEY(VK_F12)) {mouseoff(); ret=Quit;}
		strcpy(str,"Subgame G under construction");
		for (n=0;str[n];n++)
		{
			char str2[2]; str2[0]=str[n]; str2[1]=0;
			bwrite(n*20+50,yres/2+sin(n+framestart*0.01)*15,xres,str2,15);
		}
		if (KEY(VK_Q)) ret=Pass;
		for participants(p)
		{
			float ix=0;
			if (KEY(leftkey[p])) ix-=0.02*dt;
			if (KEY(rightkey[p])) ix+=0.02*dt;
			for (n=0;n<bm;n++) if (bo[n]==p)
				bxs[n]+=ix;
			if (KEY(upkey[p]))
				for (n=0;n<bm;n++) if (bo[n]==p)
					bys[n]-=bgr[n];
		}
		for participants(p)
		{
			void //(*rec)(int,int,int,int,unsigned char)=(numpresent==1?rect:rectss),
				(*cir)(float,float,float,unsigned char)=(numpresent==1?circlefill:circlefillss),
				//(*lin)(float,float,float,float,unsigned char)=(numpresent==1?line:liness),
				(*bit)(int,int,unsigned char *)=(numpresent==1?mskbit:mskbitss);
			int ox,oy;
			x_origin=xorig[p]; y_origin=yorig[p];
			for (x=0;x<gxs;x++) if ((x+1)*50-cx[p]>=0 && (ox=x*50-cx[p])<(numpresent==1?xres:xres/2))
				for (y=0;y<gys;y++) if ((y+1)*50-cy[p]>=0 && (oy=y*50-cy[p])<(numpresent==1?yres:yres/2))
				{
					i=grid[x][y];
					if (i>0 && i<100) bit(ox,oy,block[i]);
					else if (i==100) bit(ox+12,oy+25,crystal);
				}
			for (n=0;n<bm;n++)
			{
				cir(bx[n]-cx[p],by[n]-cy[p],br[n],col[bo[n]]);
				cir(bx[n]+br[n]*0.4-cx[p],by[n]-br[n]*0.4-cy[p],br[n]*0.1,15);
			}
		}
		for participants(p)
		{
			float ax=0,ay=0,at=0,mx,my;
			for (n=0;n<bm;n++) if (bo[n]==p)
				{ax+=bx[n]; ay+=by[n]; at++;}
			if (at>0) {ax/=at; ay/=at;}
			ax-=xres/(numpresent==1?2:4)+cx[p];
			ay-=yres/(numpresent==1?2:4)+cy[p];
			mx=Min((numpresent==1?1e-6:8e-6)*sq(ax),1.0/Max(dt,1));
			my=Min((numpresent==1?1e-6:8e-6)*sq(ay),1.0/Max(dt,1));
			cx[p]+=dt*ax*mx; cy[p]+=dt*ay*my;
		}
		for (n=0;n<bm;n++)
		{
			float th,rx=0,ry=0;
			bys[n]+=dt*g;
			bx[n]+=dt*bxs[n]; by[n]+=dt*bys[n];
			i=0; bgr[n]=0;
			for (th=-M_PI;th<M_PI;th+=1.0/Max(br[n],0.1))
			{
				float ox=br[n]*sin(th),oy=br[n]*cos(th),nx=bx[n]+ox,ny=by[n]+oy,
					fx=fmod(nx,50),fy=fmod(ny,50);
				int gx=floor(nx/50),gy=floor(ny/50),cgx=(int)Min(Max(gx,0),gxs-1),cgy=(int)Min(Max(gy,0),gys-1);
				unsigned char gs=grid[cgx][cgy],hit=0;
				if (gx<0 || gy<0 || gx>=gxs || gy>=gys) gs=1;
				if (gs==1) hit=1;
				else if (gs==2) hit=(fx<25 && fy<25);
				else if (gs==3) hit=(fx>50-fy);
				else if (gs==100) {grid[cgx][cgy]=0; left--;}
				if (hit) {rx+=ox; ry+=oy; i=1; if (fabs(th)<1) bgr[n]=1;}
			}
			if (i && bxs[n]*rx+bys[n]*ry>0) // Ball bounces
			{
				float dp=sqrt(rx*rx+ry*ry);
				rx/=dp+1e-6; ry/=dp+1e-6;
				dp=bxs[n]*rx+bys[n]*ry;
				bx[n]-=dt*bxs[n]+rx; by[n]-=dt*bys[n]+ry;
				bxs[n]-=2.0*dp*rx; bys[n]-=2.0*dp*ry;
				bxs[n]*=0.8; bys[n]*=0.8;
			}
			for (i=n+1;i<bm;i++) if (sq(rx=bx[i]-bx[n])+sq(ry=by[i]-by[n])<sq(br[n]+br[i])) // Ball-ball collision
			{
				float dp=sqrt(rx*rx+ry*ry),df=br[n]+br[i]-dp;
				rx/=dp+1e-6; ry/=dp+1e-6;
				dp=(bxs[i]-bxs[n])*rx+(bys[i]-bys[n])*ry;
				bx[n]-=rx*df/2; by[n]-=ry*df/2;
				bx[i]+=rx*df/2; by[i]+=ry*df/2;
				if (dp<0)
				{
					bxs[n]+=0.8*dp*rx; bys[n]+=0.8*dp*ry;
					bxs[i]-=0.8*dp*rx; bys[i]-=0.8*dp*ry;
				}
			}
		}
		if (numpresent==1) dispscores(them,score);
		else
		{
			for participants(p) numplot(xorig[p]+xres/2-15,yorig[p]+3,0,p,score[p]);
			if (numpresent==2) line(xres/2,0,xres/2,yres-1,0);
			else if (numpresent==3) {line(0,yres/2,xres-1,yres/2,0); line(xres/2,0,xres/2,yres/2,0);}
			else if (numpresent==4) {line(xres/2,0,xres/2,yres-1,0); line(0,yres/2,xres-1,yres/2,0);}
		}
		wrapbit(0,0,crystal);
		bwrite(29,10,xres,(sprintf(str,"%d",left),str),0);
		bwrite(31,10,xres,str,0);
		bwrite(30,9,xres,str,0);
		bwrite(30,11,xres,str,0);
		bwrite(30,10,xres,str,15);
		cclb();
		// Frame-sync
		do	if (dealwithmessages()) return Error;
		while (GetTickCount()<framestart+mswait);
		dt=((double)GetTickCount()-framestart)/mswait;
		if (dt>10) dt=10;
	}
	free(bx); free(by); free(bxs); free(bys); free(br); free(bo); free(bgr);
	for (x=0;x<gxs;x++) free(grid[x]); free(grid);
	for (n=0;n<blocks;n++) free(block[n]); free(block);
	free(crystal);
	return ret; // 0=Fail 1=Pass 2=Quit 3=Error
}
